import wx
import wx.lib.activex
import csv
import comtypes.client

class EventSink(object):

    def __init__(self, frame):
        self.counter = 0
        self.frame = frame

    def DataReady(self):
        self.counter +=1
        self.frame.Title= "DataReady fired {0} times".format(self.counter)

class MyApp( wx.App ): 

    def __init__( self, redirect=False, filename=None ):
        wx.App.__init__( self, redirect, filename )
        self.initUI()
        self.bindUI()

    def bindUI(self):
        self.myb1.Bind(wx.EVT_BUTTON, self.myb1click)
        self.myb2.Bind(wx.EVT_BUTTON, self.myb2click)
        self.myb3.Bind(wx.EVT_BUTTON, self.myb3click)

    def initUI(self):
        self.frame = wx.Frame( parent=None, id=wx.ID_ANY,size=(1050,950), title='Python Interface to DataRay')
        #Panel
        p = wx.Panel(self.frame, wx.ID_ANY)
        #Get Data
        self.gd = wx.lib.activex.ActiveXCtrl(p, 'DATARAYOCX.GetDataCtrl.1',)
        self.gd.ctrl.StartDriver()#The methods of the object are available through the ctrl property of the item
        sink = EventSink(self.frame)
        self.sink = comtypes.client.GetEvents(self.gd.ctrl, sink)
        #Button Panel
        b1 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,50), pos=(7, 0),axID='DATARAYOCX.ButtonCtrl.1')
        b1.ctrl.ButtonID =297 #Id's for some ActiveX controls must be set
        b2 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(125,50), pos=(7, 55),axID='DATARAYOCX.ButtonCtrl.1')
        b2.ctrl.ButtonID =104
        b3 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(125,50), pos=(135,55),axID='DATARAYOCX.ButtonCtrl.1')
        b3.ctrl.ButtonID =105
        b4 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,50), pos=(7, 110),axID='DATARAYOCX.ButtonCtrl.1')
        b4.ctrl.ButtonID =156
        b6 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,50), pos=(7, 165),axID='DATARAYOCX.ButtonCtrl.1')
        b6.ctrl.ButtonID =126
        b7 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(125,50), pos=(7, 220),axID='DATARAYOCX.ButtonCtrl.1')
        b7.ctrl.ButtonID =294
        b8 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(125,50), pos=(135,220),axID='DATARAYOCX.ButtonCtrl.1')
        b8.ctrl.ButtonID =295
        b9 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,50),pos=(750,300),axID='DATARAYOCX.ButtonCtrl.1')
        b9.ctrl.ButtonID = 158
        b10 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,50),pos=(750,355),axID='DATARAYOCX.ButtonCtrl.1')
        b10.ctrl.ButtonID = 167
        #Custom controls
        t = wx.StaticText(parent=self.frame, label="File:", pos=(7, 275))
        self.ti = wx.TextCtrl(parent=self.frame, value="C:\\Users\\Public\\Documents\\output.csv", pos=(30, 275), size=(170, -1))
        self.rb = wx.RadioBox(parent=self.frame, label="Data:", pos=(7, 300), choices=["Profile"])
        self.cb = wx.ComboBox(parent=self.frame, pos=(7,360), choices=[ "Profile_U1", "Profile_V1", "Both"])
        self.cb.SetSelection(0)
        self.myb1 = wx.Button(parent=self.frame, label="Write", pos=(7,385))
        self.myb2 = wx.Button(parent=self.frame, label="M2 Dialog", pos=(170,355))
        self.myb3 = wx.Button(parent=self.frame, label="Store M2", pos=(170, 385))
        #Pictures
        wanderer = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,250),axID='DATARAYOCX.ButtonCtrl.1',pos=(750,50))
        wanderer.ctrl.ButtonID = 197
        tpic = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(400,400), axID='DATARAYOCX.TwoDCtrl.1',pos=(270,0))
        palette = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(800,0), axID='DATARAYOCX.PaletteBarCtrl.1')
        #Profiles
        self.pv1 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(7,420))
        self.pv1.ctrl.ProfileID=15
        self.pv2 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(260,420))
        self.pv2.ctrl.ProfileID =17
        self.pv3 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(513,420))
        self.pv3.ctrl.ProfileID =19
        self.pv4 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(766,420))
        self.pv4.ctrl.ProfileID = 21
        self.pu1 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(7,580))
        self.pu1.ctrl.ProfileID=14
        self.pu2 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(260,580))
        self.pu2.ctrl.ProfileID=16
        self.pu3 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(513,580))
        self.pu3.ctrl.ProfileID=18
        self.pu4 = wx.lib.activex.ActiveXCtrl(parent=self.frame,size=(250,150),axID='DATARAYOCX.ProfilesCtrl.1',pos=(766,580))
        self.pu4.ctrl.ProfileID=20
        self.frame.Show()

    def myb1click(self,e):
        rb_selection = self.rb.GetStringSelection()
        p_selection = self.cb.GetStringSelection()
        if p_selection == "Profile_U1":
            data = self.pu1.ctrl.GetProfileDataAsVariant()
            data = [[x] for x in data]#csv.writerows accepts a list of rows where each row is a list, a list of lists
        elif p_selection == "Profile_V1":
            data = self.pv1.ctrl.GetProfileDataAsVariant()
            data = [[x] for x in data]
        else:
            datau1 = self.pu1.ctrl.GetProfileDataAsVariant()
            datav1 = self.pv1.ctrl.GetProfileDataAsVariant()
            data = [list(a) for a in zip(datau1,datav1)]#Makes a list of lists; X1 with Y1 in a list, X2 with Y2 in a list etc...
        filename = self.ti.Value
        with open(filename, 'wb') as fp:
            w = csv.writer(fp, delimiter=',')
            w.writerows(data)

    def myb2click(self,e):
        if self.gd.ctrl.IsMSquaredOpen == 0:
            self.gd.ctrl.IsMSquaredOpen = 1
        else:
            self.gd.ctrl.IsMSquaredOpen = 0
    
    def myb3click(self,e):
         print(self.gd.ctrl.GetOcxResult(122))

if __name__ == "__main__":
     app = MyApp()
     app.MainLoop()